
// 変数の定義
#include <WString.h>                 // Stringライブラリ
#include <TimerOne.h>
String inString = "                                                                        ";
String SplitCommand[2];
int OscDataCount = 0;           //オシロのデータ番号 0～511
int OscPin = 0;                 //オシロとして使うPin番号
//int dtest;
void setup() {
  ////////////////////////////////////////////////////////////////////
  // put your setup code here, to run once:
  // シリアルポートを115200 bps[ビット/秒]で初期化
  Serial.begin(115200);
  pinMode(13, OUTPUT);
  Timer1.initialize();
}
void loop() {
  ////////////////////////////////////////////////////////////////////
  // put your main code here, to run repeatedly:
  SerialStringRead();
  //inString="OscTriger,0,10000";
  split(inString, SplitCommand);
  if (SplitCommand[0] == "SetPinMode") {
    SetPinMode(SplitCommand);
  }
  else if (SplitCommand[0] == "WriteDigitalOut") {
    WriteDigitalOut(SplitCommand);
  }
  else if (SplitCommand[0] == "ReadDigitalIn") {
    ReadDigitalIn(SplitCommand);
  }
  else if (SplitCommand[0] == "ReadAnalogIn") {
    ReadAnalogIn(SplitCommand);
  }
  else if (SplitCommand[0] == "OscContinuously") {
    OscContinuouslyStart();
  }
  else if (SplitCommand[0] == "AccOnWithOsc") {         //ACC ONしオシロをスタート
    AccOnWithOsc();
  }
  else if (SplitCommand[0] == "OscStop") {
    OscStop();
  }
  //Serial.print(inString);
}
void SerialStringRead() {
  ////////////////////////////////////////////////////////////////////
  inString = "";
  while (true) {
    if (Serial.available()) {
      char inChar = Serial.read();     // charとして受信データを読む
      if (inChar != '\r') {
        inString = (inString + inChar);
      }
      else {
        break;
      }
    }
  }
}
void SetPinMode(String SplitCommand[]) {
  ////////////////////////////////////////////////////////////////////
  if (SplitCommand[2] == "DigitalOut") {
    pinMode(SplitCommand[1].toInt(), OUTPUT);
    //Serial.print(SplitCommand[1]);
    //Serial.print(SplitCommand[1]);
    //Serial.print(SplitCommand[2]);
  }
  else if (SplitCommand[2] == "DigitalIn") {
    pinMode(SplitCommand[1].toInt(), INPUT);
  }
  else if (SplitCommand[2] == "RDigitalIn") {
    pinMode(SplitCommand[1].toInt(), INPUT_PULLUP);
  }


}
void WriteDigitalOut(String SplitCommand[]) {
  ////////////////////////////////////////////////////////////////////
  if (SplitCommand[2] == "0" ) {
    digitalWrite(SplitCommand[1].toInt(), LOW);
  }
  else if (SplitCommand[2] == "1") {
    digitalWrite(SplitCommand[1].toInt(), HIGH);
  }
}
void ReadDigitalIn(String SplitCommand[]) {
  ////////////////////////////////////////////////////////////////////
  char s[16];
  int Val = digitalRead(SplitCommand[1].toInt());
  sprintf(s, "%d", Val);
  Serial.print(s);
}
void ReadAnalogIn(String SplitCommand[]) {
  ////////////////////////////////////////////////////////////////////
  char s[16];
  int Val = analogRead(SplitCommand[1].toInt());
  sprintf(s, "%d", Val);
  Serial.println(s);
}

void OscContinuouslyStart() {
  ////////////////////////////////////////////////////////////////////
  long Interval;
  char d[16];
  OscPin = SplitCommand[1].toInt();
  //SplitCommand[2].toCharArray(d, 16);
  //Interval = atol(d);
  Interval=SplitCommand[2].toInt();
  //dtest=0;
  Timer1.detachInterrupt();
  Timer1.attachInterrupt(OscContinuously, Interval);
}

void split(String in, String command[]) {
  ////////////////////////////////////////////////////////////////////
  int commaIndex = in . indexOf ( ',' );
  int secondCommaIndex = in . indexOf ( ',' , commaIndex + 1 );
  command[0] = in . substring ( 0 , commaIndex );
  command[1]  = in . substring ( commaIndex + 1 , secondCommaIndex );
  command[2]  = in. substring ( secondCommaIndex + 1 );
}

void OscContinuously() {
  ////////////////////////////////////////////////////////////////////
  int d[2];
  d[0]=analogRead(0);
  //d[0]=dtest;
  d[1]=analogRead(1);
  Serial.write((byte*)d, 4);
  //dtest++;
}
void OscStop() {
  ////////////////////////////////////////////////////////////////////
  Timer1.detachInterrupt();
}
////////////////////////////////////////////////////////////////////
void AccOnWithOsc(){      //ACC ON直後にオシロを開始させる（時間管理厳格化）
////////////////////////////////////////////////////////////////////
  long Interval;
  char d[16];
  pinMode(2,OUTPUT);          // 2PIN ACC ON制御
  OscPin = SplitCommand[1].toInt();
  SplitCommand[2].toCharArray(d, 16);
  Interval = atol(d);
  Timer1.detachInterrupt();
  digitalWrite(2, HIGH);      // ACC ON
  Timer1.attachInterrupt(OscContinuously, Interval);
}
